from .multivector import *

from .base_objects import *

# Permutations of order 2 elements
e_12 = (1 + 0j) * e_12
e_13 = (1 + 0j) * e_13
e_1i = (1 + 0j) * e_1i
e_1o = (1 + 0j) * e_1o
e_23 = (1 + 0j) * e_23
e_2i = (1 + 0j) * e_2i
e_2o = (1 + 0j) * e_2o
e_3i = (1 + 0j) * e_3i
e_3o = (1 + 0j) * e_3o
e_io = (1 + 0j) * e_io
e_21 = (-1 + 0j) * e_12
e_31 = (-1 + 0j) * e_13
e_i1 = (-1 + 0j) * e_1i
e_o1 = (-1 + 0j) * e_1o
e_32 = (-1 + 0j) * e_23
e_i2 = (-1 + 0j) * e_2i
e_o2 = (-1 + 0j) * e_2o
e_i3 = (-1 + 0j) * e_3i
e_o3 = (-1 + 0j) * e_3o
e_oi = (-2 + 0j) + (-1 + 0j) * e_io


# Permutations of order 3 elements
e_123 = (1 + 0j) * e_123
e_12i = (1 + 0j) * e_12i
e_12o = (1 + 0j) * e_12o
e_13i = (1 + 0j) * e_13i
e_13o = (1 + 0j) * e_13o
e_1io = (1 + 0j) * e_1io
e_23i = (1 + 0j) * e_23i
e_23o = (1 + 0j) * e_23o
e_2io = (1 + 0j) * e_2io
e_3io = (1 + 0j) * e_3io
e_132 = (-1 + 0j) * e_123
e_1i2 = (-1 + 0j) * e_12i
e_1o2 = (-1 + 0j) * e_12o
e_1i3 = (-1 + 0j) * e_13i
e_1o3 = (-1 + 0j) * e_13o
e_1oi = (-2 + 0j) * e_1 + (-1 + 0j) * e_1io
e_2i3 = (-1 + 0j) * e_23i
e_2o3 = (-1 + 0j) * e_23o
e_2oi = (-2 + 0j) * e_2 + (-1 + 0j) * e_2io
e_3oi = (-2 + 0j) * e_3 + (-1 + 0j) * e_3io
e_213 = (-1 + 0j) * e_123
e_21i = (-1 + 0j) * e_12i
e_21o = (-1 + 0j) * e_12o
e_31i = (-1 + 0j) * e_13i
e_31o = (-1 + 0j) * e_13o
e_i1o = (-1 + 0j) * e_1io
e_32i = (-1 + 0j) * e_23i
e_32o = (-1 + 0j) * e_23o
e_i2o = (-1 + 0j) * e_2io
e_i3o = (-1 + 0j) * e_3io
e_231 = (1 + 0j) * e_123
e_2i1 = (1 + 0j) * e_12i
e_2o1 = (1 + 0j) * e_12o
e_3i1 = (1 + 0j) * e_13i
e_3o1 = (1 + 0j) * e_13o
e_io1 = (1 + 0j) * e_1io
e_3i2 = (1 + 0j) * e_23i
e_3o2 = (1 + 0j) * e_23o
e_io2 = (1 + 0j) * e_2io
e_io3 = (1 + 0j) * e_3io
e_312 = (1 + 0j) * e_123
e_i12 = (1 + 0j) * e_12i
e_o12 = (1 + 0j) * e_12o
e_i13 = (1 + 0j) * e_13i
e_o13 = (1 + 0j) * e_13o
e_o1i = (2 + 0j) * e_1 + (1 + 0j) * e_1io
e_i23 = (1 + 0j) * e_23i
e_o23 = (1 + 0j) * e_23o
e_o2i = (2 + 0j) * e_2 + (1 + 0j) * e_2io
e_o3i = (2 + 0j) * e_3 + (1 + 0j) * e_3io
e_321 = (-1 + 0j) * e_123
e_i21 = (-1 + 0j) * e_12i
e_o21 = (-1 + 0j) * e_12o
e_i31 = (-1 + 0j) * e_13i
e_o31 = (-1 + 0j) * e_13o
e_oi1 = (-2 + 0j) * e_1 + (-1 + 0j) * e_1io
e_i32 = (-1 + 0j) * e_23i
e_o32 = (-1 + 0j) * e_23o
e_oi2 = (-2 + 0j) * e_2 + (-1 + 0j) * e_2io
e_oi3 = (-2 + 0j) * e_3 + (-1 + 0j) * e_3io


# Permutations of order 4 elements
e_123i = (1 + 0j) * e_123i
e_123o = (1 + 0j) * e_123o
e_12io = (1 + 0j) * e_12io
e_13io = (1 + 0j) * e_13io
e_23io = (1 + 0j) * e_23io
e_12i3 = (-1 + 0j) * e_123i
e_12o3 = (-1 + 0j) * e_123o
e_12oi = (-2 + 0j) * e_12 + (-1 + 0j) * e_12io
e_13oi = (-2 + 0j) * e_13 + (-1 + 0j) * e_13io
e_23oi = (-2 + 0j) * e_23 + (-1 + 0j) * e_23io
e_132i = (-1 + 0j) * e_123i
e_132o = (-1 + 0j) * e_123o
e_1i2o = (-1 + 0j) * e_12io
e_1i3o = (-1 + 0j) * e_13io
e_2i3o = (-1 + 0j) * e_23io
e_13i2 = (1 + 0j) * e_123i
e_13o2 = (1 + 0j) * e_123o
e_1io2 = (1 + 0j) * e_12io
e_1io3 = (1 + 0j) * e_13io
e_2io3 = (1 + 0j) * e_23io
e_1i23 = (1 + 0j) * e_123i
e_1o23 = (1 + 0j) * e_123o
e_1o2i = (2 + 0j) * e_12 + (1 + 0j) * e_12io
e_1o3i = (2 + 0j) * e_13 + (1 + 0j) * e_13io
e_2o3i = (2 + 0j) * e_23 + (1 + 0j) * e_23io
e_1i32 = (-1 + 0j) * e_123i
e_1o32 = (-1 + 0j) * e_123o
e_1oi2 = (-2 + 0j) * e_12 + (-1 + 0j) * e_12io
e_1oi3 = (-2 + 0j) * e_13 + (-1 + 0j) * e_13io
e_2oi3 = (-2 + 0j) * e_23 + (-1 + 0j) * e_23io
e_213i = (-1 + 0j) * e_123i
e_213o = (-1 + 0j) * e_123o
e_21io = (-1 + 0j) * e_12io
e_31io = (-1 + 0j) * e_13io
e_32io = (-1 + 0j) * e_23io
e_21i3 = (1 + 0j) * e_123i
e_21o3 = (1 + 0j) * e_123o
e_21oi = (2 + 0j) * e_12 + (1 + 0j) * e_12io
e_31oi = (2 + 0j) * e_13 + (1 + 0j) * e_13io
e_32oi = (2 + 0j) * e_23 + (1 + 0j) * e_23io
e_231i = (1 + 0j) * e_123i
e_231o = (1 + 0j) * e_123o
e_2i1o = (1 + 0j) * e_12io
e_3i1o = (1 + 0j) * e_13io
e_3i2o = (1 + 0j) * e_23io
e_23i1 = (-1 + 0j) * e_123i
e_23o1 = (-1 + 0j) * e_123o
e_2io1 = (-1 + 0j) * e_12io
e_3io1 = (-1 + 0j) * e_13io
e_3io2 = (-1 + 0j) * e_23io
e_2i13 = (-1 + 0j) * e_123i
e_2o13 = (-1 + 0j) * e_123o
e_2o1i = (-2 + 0j) * e_12 + (-1 + 0j) * e_12io
e_3o1i = (-2 + 0j) * e_13 + (-1 + 0j) * e_13io
e_3o2i = (-2 + 0j) * e_23 + (-1 + 0j) * e_23io
e_2i31 = (1 + 0j) * e_123i
e_2o31 = (1 + 0j) * e_123o
e_2oi1 = (2 + 0j) * e_12 + (1 + 0j) * e_12io
e_3oi1 = (2 + 0j) * e_13 + (1 + 0j) * e_13io
e_3oi2 = (2 + 0j) * e_23 + (1 + 0j) * e_23io
e_312i = (1 + 0j) * e_123i
e_312o = (1 + 0j) * e_123o
e_i12o = (1 + 0j) * e_12io
e_i13o = (1 + 0j) * e_13io
e_i23o = (1 + 0j) * e_23io
e_31i2 = (-1 + 0j) * e_123i
e_31o2 = (-1 + 0j) * e_123o
e_i1o2 = (-1 + 0j) * e_12io
e_i1o3 = (-1 + 0j) * e_13io
e_i2o3 = (-1 + 0j) * e_23io
e_321i = (-1 + 0j) * e_123i
e_321o = (-1 + 0j) * e_123o
e_i21o = (-1 + 0j) * e_12io
e_i31o = (-1 + 0j) * e_13io
e_i32o = (-1 + 0j) * e_23io
e_32i1 = (1 + 0j) * e_123i
e_32o1 = (1 + 0j) * e_123o
e_i2o1 = (1 + 0j) * e_12io
e_i3o1 = (1 + 0j) * e_13io
e_i3o2 = (1 + 0j) * e_23io
e_3i12 = (1 + 0j) * e_123i
e_3o12 = (1 + 0j) * e_123o
e_io12 = (1 + 0j) * e_12io
e_io13 = (1 + 0j) * e_13io
e_io23 = (1 + 0j) * e_23io
e_3i21 = (-1 + 0j) * e_123i
e_3o21 = (-1 + 0j) * e_123o
e_io21 = (-1 + 0j) * e_12io
e_io31 = (-1 + 0j) * e_13io
e_io32 = (-1 + 0j) * e_23io
e_i123 = (-1 + 0j) * e_123i
e_o123 = (-1 + 0j) * e_123o
e_o12i = (-2 + 0j) * e_12 + (-1 + 0j) * e_12io
e_o13i = (-2 + 0j) * e_13 + (-1 + 0j) * e_13io
e_o23i = (-2 + 0j) * e_23 + (-1 + 0j) * e_23io
e_i132 = (1 + 0j) * e_123i
e_o132 = (1 + 0j) * e_123o
e_o1i2 = (2 + 0j) * e_12 + (1 + 0j) * e_12io
e_o1i3 = (2 + 0j) * e_13 + (1 + 0j) * e_13io
e_o2i3 = (2 + 0j) * e_23 + (1 + 0j) * e_23io
e_i213 = (1 + 0j) * e_123i
e_o213 = (1 + 0j) * e_123o
e_o21i = (2 + 0j) * e_12 + (1 + 0j) * e_12io
e_o31i = (2 + 0j) * e_13 + (1 + 0j) * e_13io
e_o32i = (2 + 0j) * e_23 + (1 + 0j) * e_23io
e_i231 = (-1 + 0j) * e_123i
e_o231 = (-1 + 0j) * e_123o
e_o2i1 = (-2 + 0j) * e_12 + (-1 + 0j) * e_12io
e_o3i1 = (-2 + 0j) * e_13 + (-1 + 0j) * e_13io
e_o3i2 = (-2 + 0j) * e_23 + (-1 + 0j) * e_23io
e_i312 = (-1 + 0j) * e_123i
e_o312 = (-1 + 0j) * e_123o
e_oi12 = (-2 + 0j) * e_12 + (-1 + 0j) * e_12io
e_oi13 = (-2 + 0j) * e_13 + (-1 + 0j) * e_13io
e_oi23 = (-2 + 0j) * e_23 + (-1 + 0j) * e_23io
e_i321 = (1 + 0j) * e_123i
e_o321 = (1 + 0j) * e_123o
e_oi21 = (2 + 0j) * e_12 + (1 + 0j) * e_12io
e_oi31 = (2 + 0j) * e_13 + (1 + 0j) * e_13io
e_oi32 = (2 + 0j) * e_23 + (1 + 0j) * e_23io


# Permutations of order 5 elements
e_123io = (1 + 0j) * e_123io
e_123oi = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_12i3o = (-1 + 0j) * e_123io
e_12io3 = (1 + 0j) * e_123io
e_12o3i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_12oi3 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_132io = (-1 + 0j) * e_123io
e_132oi = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_13i2o = (1 + 0j) * e_123io
e_13io2 = (-1 + 0j) * e_123io
e_13o2i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_13oi2 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_1i23o = (1 + 0j) * e_123io
e_1i2o3 = (-1 + 0j) * e_123io
e_1i32o = (-1 + 0j) * e_123io
e_1i3o2 = (1 + 0j) * e_123io
e_1io23 = (1 + 0j) * e_123io
e_1io32 = (-1 + 0j) * e_123io
e_1o23i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_1o2i3 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_1o32i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_1o3i2 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_1oi23 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_1oi32 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_213io = (-1 + 0j) * e_123io
e_213oi = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_21i3o = (1 + 0j) * e_123io
e_21io3 = (-1 + 0j) * e_123io
e_21o3i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_21oi3 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_231io = (1 + 0j) * e_123io
e_231oi = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_23i1o = (-1 + 0j) * e_123io
e_23io1 = (1 + 0j) * e_123io
e_23o1i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_23oi1 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_2i13o = (-1 + 0j) * e_123io
e_2i1o3 = (1 + 0j) * e_123io
e_2i31o = (1 + 0j) * e_123io
e_2i3o1 = (-1 + 0j) * e_123io
e_2io13 = (-1 + 0j) * e_123io
e_2io31 = (1 + 0j) * e_123io
e_2o13i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_2o1i3 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_2o31i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_2o3i1 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_2oi13 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_2oi31 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_312io = (1 + 0j) * e_123io
e_312oi = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_31i2o = (-1 + 0j) * e_123io
e_31io2 = (1 + 0j) * e_123io
e_31o2i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_31oi2 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_321io = (-1 + 0j) * e_123io
e_321oi = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_32i1o = (1 + 0j) * e_123io
e_32io1 = (-1 + 0j) * e_123io
e_32o1i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_32oi1 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_3i12o = (1 + 0j) * e_123io
e_3i1o2 = (-1 + 0j) * e_123io
e_3i21o = (-1 + 0j) * e_123io
e_3i2o1 = (1 + 0j) * e_123io
e_3io12 = (1 + 0j) * e_123io
e_3io21 = (-1 + 0j) * e_123io
e_3o12i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_3o1i2 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_3o21i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_3o2i1 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_3oi12 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_3oi21 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_i123o = (-1 + 0j) * e_123io
e_i12o3 = (1 + 0j) * e_123io
e_i132o = (1 + 0j) * e_123io
e_i13o2 = (-1 + 0j) * e_123io
e_i1o23 = (-1 + 0j) * e_123io
e_i1o32 = (1 + 0j) * e_123io
e_i213o = (1 + 0j) * e_123io
e_i21o3 = (-1 + 0j) * e_123io
e_i231o = (-1 + 0j) * e_123io
e_i23o1 = (1 + 0j) * e_123io
e_i2o13 = (1 + 0j) * e_123io
e_i2o31 = (-1 + 0j) * e_123io
e_i312o = (-1 + 0j) * e_123io
e_i31o2 = (1 + 0j) * e_123io
e_i321o = (1 + 0j) * e_123io
e_i32o1 = (-1 + 0j) * e_123io
e_i3o12 = (-1 + 0j) * e_123io
e_i3o21 = (1 + 0j) * e_123io
e_io123 = (1 + 0j) * e_123io
e_io132 = (-1 + 0j) * e_123io
e_io213 = (-1 + 0j) * e_123io
e_io231 = (1 + 0j) * e_123io
e_io312 = (1 + 0j) * e_123io
e_io321 = (-1 + 0j) * e_123io
e_o123i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o12i3 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o132i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o13i2 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o1i23 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o1i32 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o213i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o21i3 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o231i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o23i1 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o2i13 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o2i31 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o312i = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o31i2 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o321i = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_o32i1 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o3i12 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_o3i21 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_oi123 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_oi132 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_oi213 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
e_oi231 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_oi312 = (-2 + 0j) * e_123 + (-1 + 0j) * e_123io
e_oi321 = (2 + 0j) * e_123 + (1 + 0j) * e_123io
